const Discord = require('discord.js');
const client = new Discord.Client();
const settings = require('./settings.json');

// 206... is my user id, from right-click, get user id.
const ownerID = '206757095280869377';

const cmdChars = "\."; // backslash escapes period in regexp
const scoreTimeDelay = 60000; // 60 seconds, in milliseconds
const reputationTimeDelay = 60000 * 60 * 24; // 1 day

client.on('ready',() => {
	console.log("online");
});

// Returns 1 if user_id has role_name
function hasRoleByName(message, user_id, role_name) { 
	if (!message || !user_id || !role_name) {
		console.log("check arguments to hasRoleByName");
		return null;
	}
	var member = message.guild.members.cache.find(user => user.id === user_id);
	if (!member) { return 0; }
	var role = member.roles.cache.find(role => role.name === role_name);
	if (role) { return 1; } else { return 0; }
}

// Returns the nickname, if available, or the username.
function getNickname(client, message, user_id) {
	if (!client || !message || !user_id) {
		console.log("check arguments to getNickname");
		return null;
	}

	var user = client.users.cache.find(user => user.id === user_id);
	var username = user.username;

	if (username == null || username == "") {
		username = "<@" + user_id + ">";
	}

	username = username.replace(/\'/g,"");
	username = username.replace(/\"/g,"");
	username = username.replace(/\;/g,"");
	username = username.replace(/\&/g,"");

	if (message.guild == null) { return username; }

	var member = message.guild.members.cache.find(user => user.id === user_id);

	var nickname = member.nickname;

	if (nickname == null) { return username; }

	nickname = nickname.replace(/\'/g,"");
	nickname = nickname.replace(/\"/g,"");
	nickname = nickname.replace(/\;/g,"");
	nickname = nickname.replace(/\&/g,"");

	return nickname;
}


// createdTimestamp = ms since epoc
// { id: message.author.id, when: message.createdTimestamp }
var lastScoredMessage = [];

function addScore(msg) {
	if (!msg) return;
	console.log(msg.author.id + " has gained Score.");
	// update database
	return;
	var str = "";
	str += "<@" + msg.author.id + "> has Leveled.";
	msg.channel.send(str);
}

function removeScoredMessage(user_id) {
	if (!user_id) return;
	lastScoredMessage = lastScoredMessage.filter(function(a) {
		return a.id != user_id;
	});
	//console.log("removed: " + user_id);
	//console.log(lastScoredMessage);
}

function addScoredMessage(msg) {
	if (!msg) return;
	var arr = { id: msg.author.id, when: msg.createdTimestamp };
	lastScoredMessage.push(arr);
	//console.log("added: " + msg.author.id);
	//console.log(lastScoredMessage);
}

client.on('message', message => {

	if (message.author === client.user) return;
	if (message.author.bot) return;

	//console.log(message.author.id + ":" + message.author.username);
	//console.log(message.content);

	// ************************************************************
	// Count posts

	//console.log(message.author.id);
	//console.log(message.createdTimestamp);

	var filtered = lastScoredMessage.filter(function(a) {
		return a.id == message.author.id;
	});	

	//console.log(lastScoredMessage);
	//console.log(filtered);

	// user has already posted something, find how long ago
	if ( filtered.length > 0 ) {
		// this createdTimestamp - last createdTimestamp = ms since last message
		if ( (message.createdTimestamp - filtered[0].when) > scoreTimeDelay ) {
			addScore(message);
			removeScoredMessage(message.author.id);
			addScoredMessage(message);			
		}
		// keeps old record
	// no messages since bot start, give them score
	} else {	
		addScore(message);
		addScoredMessage(message);			
	}

	// ************************************************************
	// Help and Reputation

	if (message.content.startsWith(cmdChars)) {

		// ^ start
		// . any character except line breaks
		// * 0 or more times
		// ()'s group capture
		// $ end of line
		var regex = new RegExp("^" + cmdChars + "(.*)$");	

		var strMessage = message.content;
		var result = strMessage.match(regex);
		if (!result) {
			return;
		}	
		//console.log(result);

		var cmd = result[1];

		//console.log(cmd);

		if (cmd == "help rep") {
			var str = "";
			str += "Sir Rep Level supports these commands:\n";
			str += "\t" + cmdChars + "rep @name\n";
			str += "\t" + cmdChars + "level [optional @name]\n";
			str += "\t" + cmdChars + "top\n";
			str += "\n";
			str += "\tAdmins Only:\n";
			str += "\tadjust rep @name [amount]\n";
			str += "\tadjust score @name [amount]\n";
			str += "\treset all rep\n";
			str += "\treset all level\n";
			str += "\tconfigure\n";
			str += "\n";

			str += "Bot by ";
			// 206... is my user id, from right-click, get user id.
			str += getNickname(client, message,'206757095280869377');
			// the < > prevents a website preview from being shown.
			str += ", <http://www.Cattail.Nu>\n";
			message.channel.send(str);
		}

		if (cmd.startsWith("level")) {
		}

		if (cmd == "top" ) {
		}


		if (cmd.startsWith("rep ")) {
			var user = message.mentions.users.first();
			if (user) {
				// if enough time elapsed : reputationTimeDelay
				// add reputation
				// update last_gave_rep_on
				// update nickname (author and receiver)
				// log who gave rep to whom when
			}
		}

		if (cmd == "reset all rep") {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }
			
			// set all reputation to 0
		}

		if (cmd == "reset all level") {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }
			
			// set all level to 0
			// set all score to 0
		}


		if (cmd.startsWith("adjust score ")) {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }

			var user = message.mentions.users.first();
			if (user) {
				// update user record
			}
		}

		if (cmd.startsWith("adjust rep ")) {
			// only me.
			if (message.author.id != ownerID ) { return; }
			// Admins only.
			//if ( !hasRoleByName(message, message.author.id, "Admin") ) { return; }

			var user = message.mentions.users.first();
			if (user) {
				// update user record
			}
		}

		if (cmd == "configure") {
			if (message.author.id != ownerID) { return; }
		}
	
	} // end if (message.content.startsWith(cmdChars))

/*
	user_id
	nickname at time of entry
	last_gave_rep_on
	score
	level
	reputation
*/

}); // end client.on

/*
// If they leave and come back, do we want them to start over?
client.on("guildMemberRemove", (member) => {
	// remove person from database
});
*/

client.on('error', function (err) {
  console.log('Global error handler called:\n');
  if(err) {console.log(err);}
});

client.login(settings.token);

